
package sample.ACSE_Request;

import com.objsys.asn1j.runtime.*;
import com.objsys.csta2.*;

public class Reader
{
	public static void main(String[] args)
	{
		String filename = new StringBuffer("message.dat").toString();
		boolean trace = true;
		
		// Process command line arguments
		
		if (args.length > 0)
		{
			for (int i = 0; i < args.length; i++)
			{
				if (args[i].equals("-v"))
					Diag.instance().setEnabled(true);
				else if (args[i].equals("-i"))
					filename = new StringBuffer(args[++i]).toString();
				else if (args[i].equals("-notrace"))
					trace = false;
				else
				{
					System.out.println("usage: Reader [ -v ] [ -i <filename> ]");
					System.out.println("   -v  verbose mode: print trace info");
					System.out.println("   -i <filename>  " + "read Encoded msg from <filename>");
					System.out.println("   -notrace  do not display trace info");
					return ;
				}
			}
		}
		
		try
		{
			// Create an input file stream object
			
			java.io.FileInputStream ins = new java.io.FileInputStream(filename);
			
			// Create a Decode buffer object
			
			Asn1BerDecodeBuffer decodeBuffer = new Asn1BerDecodeBuffer(ins);
			
			// Read and Decode the message
			
			ACSE_apdu acse = new ACSE_apdu();
			acse.decode(decodeBuffer);
			if (trace)
			{
				System.out.println("Decode was successful");
				acse.print(System.out, "pdu", 0);
			}
		}
		catch (Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			return ;
		}
	}
}

